------------------------------------------------------------------------
-- Free variables
------------------------------------------------------------------------

-- # import Explicit
-- # import Implicit

infix 40 ∈, ∈⁻

------------------------------------------------------------------------
-- Is a certain variable free in a term?

mutual

  (∈⁻) (Γ : Ctxt) (σ, τ : Ty Γ) (t : Γ ⊢ τ)
    : Γ ∋ σ -> Tm⁻ t -> Set
  (∈⁻) = InTm _ _ _ _

  data InTm :  (Γ : Ctxt) -> (σ, τ : Ty Γ) -> (t : Γ ⊢ τ)
            -> Γ ∋ σ -> Tm⁻ t -> Set where
    varIn (Γ : Ctxt) (σ, τ : Ty Γ) (v¹ : Γ ∋ τ) (v² : Γ ∋ σ)
      : v¹ ≈∋ v² -> v¹ ∈⁻ var⁻ v²
    λIn (Γ : Ctxt) (σ, τ₁ : Ty Γ) (τ₂ : Ty (Γ ▻ τ₁))
        (t : Γ ▻ τ₁ ⊢ τ₂) (τ⁻₁ : Ty⁻ τ₁) (t⁻ : Tm⁻ t) (v : Γ ∋ σ)
      : vs v τ₁ ∈⁻ t⁻ -> v ∈⁻ λ⁻ τ⁻₁ t⁻
    appInˡ (Γ : Ctxt) (σ, τ₁ : Ty Γ) (τ₂ : Ty (Γ ▻ τ₁))
           (t₁ : Γ ⊢ Π τ₁ τ₂) (t₂ : Γ ⊢ τ₁) (t⁻₁ : Tm⁻ t₁) (v : Γ ∋ σ)
      : v ∈⁻ t⁻₁ -> (t⁻₂ : Tm⁻ t₂) -> v ∈⁻ t⁻₁ @⁻ t⁻₂
    appInʳ (Γ : Ctxt) (σ, τ₁ : Ty Γ) (τ₂ : Ty (Γ ▻ τ₁))
           (t₁ : Γ ⊢ Π τ₁ τ₂) (t₂ : Γ ⊢ τ₁) (t⁻₂ : Tm⁻ t₂) (v : Γ ∋ σ)
      : v ∈⁻ t⁻₂ -> (t⁻₁ : Tm⁻ t₁) -> v ∈⁻ t⁻₁ @⁻ t⁻₂
    castIn (Γ : Ctxt) (σ, τ¹, τ² : Ty Γ)
           (t¹ : Γ ⊢ τ¹) (t² : Γ ⊢ τ²) (t⁻ : Tm⁻ t¹) (v : Γ ∋ σ)
      : v ∈⁻ t⁻ -> (eqt : t¹ ≈⊢ t²) -> v ∈⁻ t⁻ ∷≡⊢⁻ eqt

(∈) (Γ : Ctxt) (σ, τ : Ty Γ)
  : Γ ∋ σ -> Γ ⊢ τ -> Set
v ∈ t = v ∈⁻ tmToTm⁻ t
